# Contribute

## Introduction

First, thank you for considering contributing to JavaScript Enhancements! It's people like you that make the open source community such a great community! 😊

We welcome any type of contribution, not only code. You can help with 
- **QA**: file bug reports, the more details you can give the better (e.g. screenshots with the console open)
- **Marketing**: writing blog posts, howto's, videos, ...
- **Code**: take a look at the [open issues](https://github.com/pichillilorenzo/JavaScriptEnhancements/issues). Even if you can't write code, commenting on them, showing that you care about a given issue matters. It helps us triage them.
- **Money**: we welcome financial contributions in full transparency on [Open Collective](https://opencollective.com/javascriptenhancements), [Patreon](https://www.patreon.com/bePatron?u=9269604) or using [PayPal](https://www.paypal.me/LorenzoPichilli).

## Your First Contribution

Working on your first Pull Request? You can learn how from this *free* series, [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github).

## Submitting code

Any code change should be submitted as a pull request. Please, before submit it, run the tests using the [UnitTesting](https://github.com/SublimeText/UnitTesting) Sublime Text package (in this case you need to install manually also this package: [Keypress](https://github.com/randy3k/Keypress)). The description should explain what the code does and give steps to execute it. If necessary, the description should also contain screenshots showing up the new behaviour. The pull request should also contain tests.
When you are changing the code of this plugin, I recommend to use [AutomaticPackageReloader](https://github.com/randy3k/AutomaticPackageReloader) to test quickly the new changes. It automatically reload submodules while developing a Sublime Text package without the need of reopening the editor.

## Code review process

The bigger the pull request, the longer it will take to review and merge. Try to break down large pull requests in smaller chunks that are easier to review and merge.
It is also always helpful to have some context for your pull request. What was the purpose? Why does it matter to you?

## Issues/Questions

If you have any problems, create an [issue](https://github.com/pichillilorenzo/JavaScriptEnhancements/issues) (protip: do a quick search first to see if someone else didn't ask the same question before!). For small questions, you can use [![Gitter](https://img.shields.io/gitter/room/nwjs/nw.js.svg)](https://gitter.im/JavaScriptEnhancements/Lobby).

Email me for any questions or doubts about this project on: [pichillilorenzo@gmail.com](mailto:pichillilorenzo@gmail.com)

## Feature request/enhancement

For feature requests/enhancement, create an issue or use [![Gitter](https://img.shields.io/gitter/room/nwjs/nw.js.svg)](https://gitter.im/JavaScriptEnhancements/Features).

## Financial contributions

If this project helps you reduce time to develop and also you like it, please support it with a donation on [Patreon](https://www.patreon.com/bePatron?u=9269604), [Open Collective](https://opencollective.com/javascriptenhancements) or using [PayPal](https://www.paypal.me/LorenzoPichilli) 😄👍. Thanks!

[![paypal](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.me/LorenzoPichilli)
[![Become a Patron](https://img.shields.io/badge/-Become%20a%20Patron!-red.svg?style=for-the-badge)](https://www.patreon.com/bePatron?u=9269604)
<a href="https://opencollective.com/javascriptenhancements/donate" target="_blank">
  <img alt="opencollective" src="https://opencollective.com/javascriptenhancements/donate/button@2x.png?color=blue" width=300 />
</a>

## Credits

### Sponsors

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [[Become a sponsor](https://opencollective.com/javascriptenhancements#sponsor)]

<!-- 
<a href="https://opencollective.com/javascriptenhancements/sponsor/0/website" target="_blank"><img src="https://opencollective.com/javascriptenhancements/sponsor/0/avatar.svg"></a>
-->
<a href="https://opencollective.com/javascriptenhancements#sponsors" target="_blank"><img src="https://opencollective.com/javascriptenhancements/sponsors.svg?width=890"></a>

### Backers

Thank you to all our backers! 🙏 [[Become a backer](https://opencollective.com/javascriptenhancements#backer)]

<a href="https://opencollective.com/javascriptenhancements#backers" target="_blank"><img src="https://opencollective.com/javascriptenhancements/backers.svg?width=890"></a>

### Contributors

This project exists thanks to all the people who contribute. [[Contribute](CONTRIBUTING.md)].
<a href="graphs/contributors"><img src="https://opencollective.com/javascriptenhancements/contributors.svg?width=890" /></a>


<!-- This `CONTRIBUTING.md` is based on @nayafia's template https://github.com/nayafia/contributing-template -->
